<template>
  <div style="width: 100%; padding: 0px 15px">
    <byForm :formConfig="formConfig" :formOption="formOption" v-model="formData.data" :rules="rules" ref="submit">
      <template #seller>
        <div style="width: 100%">
          <el-form-item prop="sellCorporationId">
            <el-select v-model="formData.data.sellCorporationId" style="width: 100%" disabled>
              <el-option v-for="item in corporationList" :key="item.value" :label="item.label" :value="item.value" />
            </el-select>
          </el-form-item>
          <el-row style="margin-top: 20px; width: 100%">
            <el-col :span="8">
              <el-form-item label="地址" prop="sellCountryId">
                <el-input v-model="formData.data.sellCountryId" placeholder="请输入国家" />
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label=" " prop="sellProvinceId">
                <el-input v-model="formData.data.sellProvinceId" placeholder="请输入省/州" />
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label=" " prop="sellCityId">
                <el-input v-model="formData.data.sellCityId" placeholder="请输入城市" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row style="margin-top: 20px; width: 100%">
            <el-col :span="24">
              <el-form-item prop="sellAddress">
                <el-input v-model="formData.data.sellAddress" type="textarea"> </el-input>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row style="margin-top: 20px; width: 100%">
            <el-col :span="8">
              <el-form-item label="联系人" prop="sellContactName">
                <el-input v-model="formData.data.sellContactName" placeholder="请输入联系人" />
              </el-form-item>
            </el-col>
            <el-col :span="16">
              <el-form-item label=" " prop="sellContactNumber">
                <el-input v-model="formData.data.sellContactNumber" placeholder="请输入联系人电话" />
              </el-form-item>
            </el-col>
          </el-row>
        </div>
      </template>
      <template #buyer>
        <div style="width: 100%">
          <div style="width: 100%">
            <el-form-item prop="buyCorporationId">
              <el-select v-model="formData.data.buyCorporationId" style="width: 100%" @change="changeCustomer">
                <el-option v-for="item in customerList" :key="item.value" :label="item.label" :value="item.value" />
              </el-select>
            </el-form-item>
            <el-row style="margin-top: 20px; width: 100%">
              <el-col :span="6">
                <el-form-item label="地址" prop="buyCountryId">
                  <el-select v-model="formData.data.buyCountryId" placeholder="国家" @change="(val) => getCityData(val, '20', true)">
                    <el-option v-for="item in countryData" :label="item.chineseName" :value="item.id"> </el-option>
                  </el-select>
                </el-form-item>
              </el-col>
              <el-col :span="6">
                <el-form-item label=" " prop="buyProvinceId">
                  <el-select v-model="formData.data.buyProvinceId" placeholder="省/洲" @change="(val) => getCityData(val, '30', true)">
                    <el-option v-for="item in provinceData" :label="item.name" :value="item.id"> </el-option>
                  </el-select>
                </el-form-item>
              </el-col>
              <el-col :span="6">
                <el-form-item label=" " prop="buyCityId">
                  <el-select v-model="formData.data.buyCityId" placeholder="城市">
                    <el-option v-for="item in cityData" :label="item.name" :value="item.id"> </el-option>
                  </el-select>
                </el-form-item>
              </el-col>
              <el-col :span="6">
                <el-form-item label=" " prop="buyPostalCode">
                  <el-input v-model="formData.data.buyPostalCode" placeholder="请输入邮编" />
                </el-form-item>
              </el-col>
            </el-row>
            <el-row style="margin-top: 20px; width: 100%">
              <el-col :span="24">
                <el-form-item prop="buyAddress">
                  <el-input v-model="formData.data.buyAddress" type="textarea"> </el-input>
                </el-form-item>
              </el-col>
            </el-row>
            <el-row style="margin-top: 20px; width: 100%">
              <el-col :span="8">
                <el-form-item label="联系人" prop="buyContactName">
                  <el-autocomplete
                    v-model="formData.data.buyContactName"
                    :fetch-suggestions="querySearchPerson"
                    clearable
                    class="inline-input w-50"
                    placeholder="请输入联系人"
                    @select="handlePerson">
                  </el-autocomplete>
                </el-form-item>
              </el-col>
              <el-col :span="16">
                <el-form-item label=" " prop="buyContactNumber">
                  <el-input v-model="formData.data.buyContactNumber" placeholder="请输入联系人电话" />
                </el-form-item>
              </el-col>
            </el-row>
          </div>
        </div>
      </template>
      <template #payment>
        <div style="width: 100%">
          <el-row style="margin-top: 20px; width: 100%">
            <el-col :span="6">
              <el-form-item label="币种" prop="currency">
                <el-select v-model="formData.data.currency" placeholder="请选择币种" style="width: 100%">
                  <el-option v-for="item in accountCurrency" :key="item.value" :label="item.label" :value="item.value" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="付款方式" prop="paymentMethod">
                <el-select v-model="formData.data.paymentMethod" placeholder="请选择付款方式" style="width: 100%">
                  <el-option v-for="item in fundsPaymentMethod" :key="item.value" :label="item.label" :value="item.value" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="预付比例 (%)" prop="advanceRatio">
                <el-input-number
                  v-model="formData.data.advanceRatio"
                  placeholder="请输入预付比例"
                  style="width: 100%"
                  :precision="2"
                  :controls="false"
                  :min="0"
                  :max="100" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row style="margin-top: 20px; width: 100%">
            <el-col :span="18">
              <el-form-item label="付款条件" prop="remark">
                <el-input v-model="formData.data.remark" :rows="2" type="textarea" placeholder="请输入付款条件" />
              </el-form-item>
            </el-col>
          </el-row>
        </div>
      </template>
      <template #delivery>
        <div style="width: 100%">
          <el-row style="margin-top: 20px; width: 100%">
            <el-col :span="6">
              <el-form-item label="报价有效期 (天)" prop="effective">
                <el-input-number v-model="formData.data.effective" placeholder="请输入有效期" style="width: 100%" :precision="0" :controls="false" :min="0" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="交货期限" prop="deliveryTime">
                <el-date-picker v-model="formData.data.deliveryTime" type="date" placeholder="请选择交货期限" value-format="YYYY-MM-DD" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="运输方式" prop="transportMethod">
                <el-select v-model="formData.data.transportMethod" placeholder="请选择运输方式" style="width: 100%">
                  <el-option v-for="item in shippingMethod" :key="item.value" :label="item.label" :value="item.value" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="运输说明" prop="transportRemark">
                <el-input v-model="formData.data.transportRemark" placeholder="请输入运输说明" />
              </el-form-item>
            </el-col>
          </el-row>
        </div>
      </template>
      <template #commodity>
        <div style="width: 100%">
          <el-button type="primary" @click="openProductCompany = true" plain>标准产品库</el-button>
          <el-button type="primary" @click="clickCustomerProduct()" plain>客户产品库</el-button>
          <el-table :data="formData.data.quotationProductList" style="width: 100%; margin-top: 16px">
            <el-table-column label="商品图片" width="80">
              <template #default="{ row }">
                <div v-if="row.productId">
                  <img :src="row.fileUrl" class="pic" @click="onPicture(row.fileUrl)" />
                </div>
                <div v-else></div>
              </template>
            </el-table-column>
            <el-table-column label="商品名称" min-width="180">
              <template #default="{ row, $index }">
                <div style="width: 100%">
                  <el-form-item
                    :prop="'quotationProductList.' + $index + '.productName'"
                    :rules="rules.productName"
                    :inline-message="true"
                    class="shrinkPadding">
                    <el-input v-model="row.productName" placeholder="请输入商品名称" />
                  </el-form-item>
                </div>
              </template>
            </el-table-column>
            <el-table-column label="尺寸 cm*cm*cm" width="140">
              <template #default="{ row, $index }">
                <div style="width: 100%">
                  <el-form-item
                    :prop="'quotationProductList.' + $index + '.productModel'"
                    :rules="rules.productModel"
                    :inline-message="true"
                    class="shrinkPadding">
                    <el-input v-model="row.productModel" placeholder="请输入" />
                  </el-form-item>
                </div>
              </template>
            </el-table-column>
            <el-table-column label="数量" width="130">
              <template #default="{ row, $index }">
                <div style="width: 100%">
                  <el-form-item :prop="'quotationProductList.' + $index + '.quantity'" :rules="rules.quantity" :inline-message="true" class="shrinkPadding">
                    <el-input-number
                      v-model="row.quantity"
                      placeholder="请输入"
                      style="width: 100%"
                      :precision="0"
                      :controls="false"
                      :min="0"
                      @change="calculationAmount()" />
                  </el-form-item>
                </div>
              </template>
            </el-table-column>
            <el-table-column label="单价" width="140">
              <template #default="{ row, $index }">
                <div style="width: 100%">
                  <el-form-item :prop="'quotationProductList.' + $index + '.price'" :rules="rules.price" :inline-message="true" class="shrinkPadding">
                    <el-input-number
                      v-model="row.price"
                      placeholder="请输入"
                      style="width: 100%"
                      :precision="2"
                      :controls="false"
                      :min="0"
                      @change="calculationAmount()" />
                  </el-form-item>
                </div>
              </template>
            </el-table-column>
            <el-table-column label="贸易方式" width="140">
              <template #default="{ row, $index }">
                <div style="width: 100%">
                  <el-form-item
                    :prop="'quotationProductList.' + $index + '.tradeMethods'"
                    :rules="rules.tradeMethods"
                    :inline-message="true"
                    class="shrinkPadding">
                    <el-select v-model="row.tradeMethods" placeholder="请选择" style="width: 100%">
                      <el-option v-for="item in tradeMethods" :key="item.value" :label="item.label" :value="item.value" />
                    </el-select>
                  </el-form-item>
                </div>
              </template>
            </el-table-column>
            <el-table-column label="包装方式" width="180">
              <template #default="{ row, $index }">
                <div style="width: 100%">
                  <el-form-item :prop="'quotationProductList.' + $index + '.packMethod'" :rules="rules.packMethod" :inline-message="true" class="shrinkPadding">
                    <el-input v-model="row.packMethod" placeholder="请输入" />
                  </el-form-item>
                </div>
              </template>
            </el-table-column>
            <el-table-column prop="amount" :label="'金额 ( ' + formData.data.currency + ' )'" width="130" />
            <el-table-column label="操作" width="60" align="center" fixed="right">
              <template #default="{ $index }">
                <el-button type="primary" link @click="handleRemove($index)">删除</el-button>
              </template>
            </el-table-column>
          </el-table>
        </div>
      </template>
      <template #otherCharge>
        <div style="width: 100%">
          <el-button type="primary" @click="clickAdd()">添加行</el-button>
          <el-table :data="formData.data.quotationPayList" style="width: 100%; margin-top: 16px">
            <el-table-column label="收费项目" width="220">
              <template #default="{ row, $index }">
                <div style="width: 100%">
                  <el-form-item :prop="'quotationPayList.' + $index + '.payName'" :rules="rules.payName" :inline-message="true">
                    <el-autocomplete v-model="row.payName" :fetch-suggestions="querySearch" clearable class="inline-input w-50" placeholder="请输入收费项目" />
                  </el-form-item>
                </div>
              </template>
            </el-table-column>
            <el-table-column label="备注">
              <template #default="{ row, $index }">
                <div style="width: 100%">
                  <el-form-item :prop="'quotationPayList.' + $index + '.remark'">
                    <el-input v-model="row.remark" placeholder="请输入备注" />
                  </el-form-item>
                </div>
              </template>
            </el-table-column>
            <el-table-column :label="'金额 ( ' + formData.data.currency + ' )'" width="130">
              <template #default="{ row, $index }">
                <div style="width: 100%">
                  <el-form-item :prop="'quotationPayList.' + $index + '.amount'" :rules="rules.amount" :inline-message="true" class="shrinkPadding">
                    <el-input-number
                      v-model="row.amount"
                      placeholder="请输入金额"
                      style="width: 100%"
                      :precision="2"
                      :controls="false"
                      :min="0"
                      @change="totalAmount()" />
                  </el-form-item>
                </div>
              </template>
            </el-table-column>
            <el-table-column label="操作" width="60" align="center" fixed="right">
              <template #default="{ $index }">
                <el-button type="primary" link @click="handleDelete($index)">删除</el-button>
              </template>
            </el-table-column>
          </el-table>
        </div>
      </template>
      <template #offerMoney>
        <div style="width: 100%; display: flex">
          <div style="width: calc(100% - 190px)"></div>
          <div style="width: 130px; padding: 0 12px">
            <el-form-item label="合同总金额" prop="amount" class="shrinkPadding">
              <el-input v-model="formData.data.amount" placeholder="合同总金额" disabled />
            </el-form-item>
          </div>
        </div>
      </template>
    </byForm>

    <el-dialog v-if="openProductCompany" v-model="openProductCompany" title="公司产品库" width="90%" append-to-body>
      <CompanyProduct :selectStatus="true" @selectProduct="selectProduct"></CompanyProduct>
    </el-dialog>

    <el-dialog v-if="openProductCustomer" v-model="openProductCustomer" title="客户产品库" width="90%" append-to-body>
      <CustomerProduct :selectStatus="true" :buyCorporationId="formData.data.buyCorporationId" @selectProduct="selectProduct"></CustomerProduct>
    </el-dialog>
  </div>
</template>

<script setup>
import byForm from "@/components/byForm/index";
import CompanyProduct from "@/views/EHSD/productLibrary/companyProduct/index";
import CustomerProduct from "@/views/EHSD/productLibrary/customerProduct/index";
import { ElMessage } from "element-plus";

const { proxy } = getCurrentInstance();
const innerMethod = ref([]);
const outsideMethod = ref([]);
const accountCurrency = ref([]);
const fundsPaymentMethod = ref([]);
const tradeMethods = ref([]);
const shippingMethod = ref([]);
const templateList = ref([]);
const corporationList = ref([]);
const customerList = ref([]);
const countryData = ref([]);
const provinceData = ref([]);
const cityData = ref([]);
const customerUserList = ref([]);
const openProductCompany = ref(false);
const openProductCustomer = ref(false);
const formData = reactive({
  data: {
    currency: "¥",
    amount: undefined,
    quotationProductList: [],
    quotationPayList: [],
  },
});
const submit = ref(null);
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const formConfig = computed(() => {
  return [
    {
      label: "合同模板",
    },
    {
      type: "select",
      label: "选择合同模板",
      prop: "contractTemplateId",
      data: templateList.value,
      fn: (val) => {
        changeTemplate(val);
      },
    },
    {
      type: "slot",
      slotName: "seller",
      label: "卖方信息",
      itemWidth: 50,
    },
    {
      type: "slot",
      slotName: "buyer",
      label: "买方信息",
      itemWidth: 50,
    },
    {
      type: "slot",
      slotName: "payment",
      label: "付款信息",
    },
    {
      type: "slot",
      slotName: "delivery",
      label: "交付信息",
    },
    {
      type: "slot",
      slotName: "commodity",
      label: "商品信息",
    },
    {
      type: "slot",
      slotName: "otherCharge",
      label: "其他收费项目",
    },
    {
      type: "slot",
      slotName: "offerMoney",
    },
  ];
});
const rules = ref({
  contractTemplateId: [{ required: true, message: "请选择合同模板", trigger: "change" }],
  buyCorporationId: [{ required: true, message: "请选择公司", trigger: "change" }],
  buyCountryId: [{ required: true, message: "请选择国家", trigger: "change" }],
  buyProvinceId: [{ required: true, message: "请选择省/州", trigger: "change" }],
  buyCityId: [{ required: true, message: "请选择城市", trigger: "change" }],
  // buyAddress: [{ required: true, message: "请输入详细地址", trigger: "blur" }],
  buyContactName: [{ required: true, message: "请输入联系人", trigger: ["change", "blur"] }],
  buyContactNumber: [{ required: true, message: "请输入联系电话", trigger: "blur" }],
  productName: [{ required: true, message: "请输入商品名称", trigger: "blur" }],
  productModel: [{ required: true, message: "请输入尺寸 cm*cm*cm", trigger: "blur" }],
  quantity: [{ required: true, message: "请输入数量", trigger: "blur" }],
  price: [{ required: true, message: "请输入单价", trigger: "blur" }],
  packMethod: [{ required: true, message: "请输入包装方式", trigger: "blur" }],
  amount: [{ required: true, message: "请输入金额", trigger: "blur" }],
  payName: [{ required: true, message: "请输入收费项目", trigger: ["change", "blur"] }],
  currency: [{ required: true, message: "请选择币种", trigger: "change" }],
  effective: [{ required: true, message: "请输入报价有效期", trigger: "blur" }],
  deliveryTime: [{ required: true, message: "请选择交货期限", trigger: "change" }],
  paymentMethod: [{ required: true, message: "请选择付款方式", trigger: "change" }],
  advanceRatio: [{ required: true, message: "请输入预付比例", trigger: "blur" }],
  tradeMethods: [{ required: true, message: "请选择贸易方式", trigger: "change" }],
  transportMethod: [{ required: true, message: "请选择运输方式", trigger: "change" }],
  transportRemark: [{ required: true, message: "请输入运输说明", trigger: "blur" }],
  remark: [{ required: true, message: "请输入付款条件", trigger: "blur" }],
});
const getDict = () => {
  proxy
    .getDictOne([
      "inner_packaging_method_ehsd",
      "outside_packaging_method_ehsd",
      "account_currency",
      "funds_payment_method",
      "trade_methods",
      "shipping_method",
    ])
    .then((res) => {
      innerMethod.value = res["inner_packaging_method_ehsd"].map((x) => ({
        label: x.dictValue,
        value: x.dictKey,
      }));
      outsideMethod.value = res["outside_packaging_method_ehsd"].map((x) => ({
        label: x.dictValue,
        value: x.dictKey,
      }));
      accountCurrency.value = res["account_currency"].map((x) => ({
        label: x.dictValue,
        value: x.dictKey,
      }));
      fundsPaymentMethod.value = res["funds_payment_method"].map((x) => ({
        label: x.dictValue,
        value: x.dictKey,
      }));
      tradeMethods.value = res["trade_methods"].map((x) => ({
        label: x.dictValue,
        value: x.dictKey,
      }));
      shippingMethod.value = res["shipping_method"].map((x) => ({
        label: x.dictValue,
        value: x.dictKey,
      }));
    });
  proxy.post("/contractTemplate/page", { pageNum: 1, pageSize: 999 }).then((res) => {
    templateList.value = res.rows.map((item) => {
      return {
        ...item,
        label: item.templateName,
        value: item.id,
      };
    });
  });
  proxy.post("/corporation/page", { pageNum: 1, pageSize: 999 }).then((res) => {
    corporationList.value = res.rows.map((item) => {
      return {
        ...item,
        label: item.name,
        value: item.id,
      };
    });
  });
  proxy.post("/customer/page", { pageNum: 1, pageSize: 999 }).then((res) => {
    customerList.value = res.rows.map((item) => {
      return {
        ...item,
        label: item.name,
        value: item.id,
      };
    });
  });
};
getDict();
const changeTemplate = (val) => {
  if (val) {
    proxy.post("/contractTemplate/detail", { id: val }).then(
      (res) => {
        proxy.post("/areaInfo/list", { parentId: "0" }).then((resCountry) => {
          let sellCountryData = resCountry.filter((item) => item.id === res.countryId);
          if (sellCountryData && sellCountryData.length > 0) {
            formData.data.sellCountryId = sellCountryData[0].chineseName;
          } else {
            formData.data.sellCountryId = "";
          }
        });
        if (res.countryId) {
          proxy.post("/areaInfo/list", { parentId: res.countryId }).then((resProvince) => {
            let sellProvinceData = resProvince.filter((item) => item.id === res.provinceId);
            if (sellProvinceData && sellProvinceData.length > 0) {
              formData.data.sellProvinceId = sellProvinceData[0].name;
            } else {
              formData.data.sellProvinceId = "";
            }
          });
        } else {
          formData.data.sellProvinceId = "";
        }
        if (res.provinceId) {
          proxy.post("/areaInfo/list", { parentId: res.provinceId }).then((resCity) => {
            let sellCityData = resCity.filter((item) => item.id === res.cityId);
            if (sellCityData && sellCityData.length > 0) {
              formData.data.sellCityId = sellCityData[0].name;
            } else {
              formData.data.sellCityId = "";
            }
          });
        } else {
          formData.data.sellCityId = "";
        }
        formData.data.sellCorporationId = res.corporationId;
        formData.data.sellContactName = res.contactName;
        formData.data.sellContactNumber = res.contactNumber;
        formData.data.sellAddress = res.address;
      },
      (err) => {
        console.log(err);
        formData.data.sellCorporationId = "";
        formData.data.sellContactName = "";
        formData.data.sellContactNumber = "";
        formData.data.sellCountryId = "";
        formData.data.sellProvinceId = "";
        formData.data.sellCityId = "";
        formData.data.sellAddress = "";
      }
    );
  } else {
    formData.data.sellCorporationId = "";
    formData.data.sellContactName = "";
    formData.data.sellContactNumber = "";
    formData.data.sellCountryId = "";
    formData.data.sellProvinceId = "";
    formData.data.sellCityId = "";
    formData.data.sellAddress = "";
  }
};
const getCityData = (id, type, isChange) => {
  proxy.post("/areaInfo/list", { parentId: id }).then((res) => {
    if (type === "20") {
      provinceData.value = res;
      if (isChange) {
        formData.data.customerState = "";
        formData.data.customerCityId = "";
      }
    } else if (type === "30") {
      cityData.value = res;
      if (isChange) {
        formData.data.customerCityId = "";
      }
    } else {
      countryData.value = res;
    }
  });
};
getCityData("0");
const changeCustomer = (val) => {
  formData.data.quotationProductList = [];
  formData.data.customerName = "";
  formData.data.customerTel = "";
  if (val) {
    proxy.post("/customer/detail", { id: val }).then(
      (res) => {
        if (res.customerUserList && res.customerUserList.length > 0) {
          formData.data.buyContactName = res.customerUserList[0].name;
          if (res.customerUserList[0].contactJson) {
            let contactJson = JSON.parse(res.customerUserList[0].contactJson);
            if (contactJson && contactJson.length > 0) {
              formData.data.buyContactNumber = contactJson[0].contactNo;
            }
          }
          customerUserList.value = res.customerUserList.map((item) => {
            return {
              ...item,
              value: item.name,
            };
          });
        }
        formData.data.buyCountryId = res.countryId;
        formData.data.buyProvinceId = res.provinceId;
        formData.data.buyCityId = res.cityId;
        formData.data.buyPostalCode = res.zipCode;
        formData.data.buyAddress = res.address;
        getCityData(formData.data.buyCountryId, "20");
        getCityData(formData.data.buyProvinceId, "30");
      },
      (err) => {
        console.log(err);
        formData.data.buyCountryId = "";
        formData.data.buyProvinceId = "";
        formData.data.buyCityId = "";
        formData.data.buyPostalCode = "";
        formData.data.buyAddress = "";
      }
    );
  } else {
    formData.data.buyCountryId = "";
    formData.data.buyProvinceId = "";
    formData.data.buyCityId = "";
    formData.data.buyPostalCode = "";
    formData.data.buyAddress = "";
  }
};
const createFilter = (queryString) => {
  return (restaurant) => {
    return restaurant.value.toLowerCase().indexOf(queryString.toLowerCase()) === 0;
  };
};
const querySearchPerson = (queryString, callback) => {
  const results = queryString ? customerUserList.value.filter(createFilter(queryString)) : customerUserList.value;
  callback(results);
};
const handlePerson = (item) => {
  formData.data.customerTel = item.phone;
};
const selectProduct = (goods) => {
  if (goods && goods.id) {
    let data = formData.data.quotationProductList.filter((item) => item.productId === goods.id);
    if (data && data.length > 0) {
      return ElMessage("该产品已添加");
    }
    let fileUrl = "";
    if (goods.fileList && goods.fileList.length > 0) {
      fileUrl = goods.fileList[0].fileUrl;
    }
    let packMethod = "";
    if (goods.innerPackMethod) {
      let innerPackMethod = goods.innerPackMethod.split(",");
      innerPackMethod.map((item) => {
        if (packMethod) {
          packMethod = packMethod + "," + proxy.dictValueLabel(item, innerMethod.value);
        } else {
          packMethod = proxy.dictValueLabel(item, innerMethod.value);
        }
      });
    }
    if (goods.outerPackMethod) {
      let outerPackMethod = goods.outerPackMethod.split(",");
      outerPackMethod.map((item) => {
        if (packMethod) {
          packMethod = packMethod + "," + proxy.dictValueLabel(item, outsideMethod.value);
        } else {
          packMethod = proxy.dictValueLabel(item, outsideMethod.value);
        }
      });
    }
    if (formData.data.quotationProductList && formData.data.quotationProductList.length > 0) {
      formData.data.quotationProductList.push({
        fileUrl: fileUrl,
        productId: goods.id,
        productName: goods.name,
        productModel: goods.productLong + "*" + goods.productWide + "*" + goods.productHigh,
        quantity: undefined,
        price: undefined,
        amount: "",
        tradeMethods: "",
        packMethod: packMethod,
      });
    } else {
      formData.data.quotationProductList = [
        {
          fileUrl: fileUrl,
          productId: goods.id,
          productName: goods.name,
          productModel: goods.productLong + "*" + goods.productWide + "*" + goods.productHigh,
          quantity: undefined,
          price: undefined,
          amount: "",
          tradeMethods: "",
          packMethod: packMethod,
        },
      ];
    }
    ElMessage({
      message: "添加成功！",
      type: "success",
    });
  } else {
    return ElMessage("选择错误");
  }
};
const onPicture = (path) => {
  window.open(path, "_blank");
};
const handleRemove = async (index) => {
  await formData.data.quotationProductList.splice(index, 1);
  totalAmount();
};
const calculationAmount = () => {
  nextTick(() => {
    if (formData.data.quotationProductList && formData.data.quotationProductList.length > 0) {
      for (let i = 0; i < formData.data.quotationProductList.length; i++) {
        let money = 0;
        if (formData.data.quotationProductList[i].quantity && formData.data.quotationProductList[i].price) {
          money = parseFloat(Number(formData.data.quotationProductList[i].quantity) * Number(formData.data.quotationProductList[i].price)).toFixed(2);
        }
        formData.data.quotationProductList[i].amount = money;
      }
    }
    nextTick(() => {
      totalAmount();
    });
  });
};
const totalAmount = () => {
  let money = 0;
  if (formData.data.quotationProductList && formData.data.quotationProductList.length > 0) {
    for (let i = 0; i < formData.data.quotationProductList.length; i++) {
      if (formData.data.quotationProductList[i].amount) {
        money = parseFloat(Number(money) + Number(formData.data.quotationProductList[i].amount)).toFixed(2);
      }
    }
  }
  if (formData.data.quotationPayList && formData.data.quotationPayList.length > 0) {
    for (let i = 0; i < formData.data.quotationPayList.length; i++) {
      if (formData.data.quotationPayList[i].amount) {
        money = parseFloat(Number(money) + Number(formData.data.quotationPayList[i].amount)).toFixed(2);
      }
    }
  }
  formData.data.amount = money;
};
const clickAdd = () => {
  if (formData.data.quotationPayList && formData.data.quotationPayList.length > 0) {
    formData.data.quotationPayList.push({
      payName: "",
      amount: undefined,
      remark: "",
    });
  } else {
    formData.data.quotationPayList = [{ payName: "", amount: undefined, remark: "" }];
  }
};
const handleDelete = async (index) => {
  await formData.data.quotationPayList.splice(index, 1);
  totalAmount();
};
const querySearch = (queryString, callback) => {
  proxy.post("/quotationPay/page", { payName: queryString }).then((res) => {
    if (res.rows && res.rows.length > 0) {
      res.rows = res.rows.map((item) => {
        return {
          ...item,
          value: item.payName,
        };
      });
      callback(res.rows);
    } else {
      callback([]);
    }
  });
};
const handleSubmit = async () => {
  let status = await submit.value.handleSubmit(() => {});
  if (status) {
    if (!(formData.data.quotationProductList && formData.data.quotationProductList.length > 0)) {
      ElMessage("请添加至少一件商品");
      return false;
    }
    return true;
  } else {
    setTimeout(() => {
      const errorDiv = document.getElementsByClassName("is-error");
      errorDiv[0].scrollIntoView();
    }, 0);
  }
  return status;
};
// 接收父组件的传值
const props = defineProps({
  queryData: Object,
});
onMounted(() => {
  if (props.queryData.priceSheetId) {
    proxy.post("/saleQuotation/detail", { id: props.queryData.priceSheetId }).then((res) => {
      for (var text in res) {
        formData.data[text] = res[text];
      }
      if (formData.data.ehsdJson) {
        let ehsdJson = JSON.parse(formData.data.ehsdJson);
        if (ehsdJson.deliveryTime) {
          formData.data.deliveryTime = ehsdJson.deliveryTime;
        }
      }
      if (formData.data.quotationProductList && formData.data.quotationProductList.length > 0) {
        for (let i = 0; i < formData.data.quotationProductList.length; i++) {
          if (formData.data.quotationProductList[i].ehsdJson) {
            let ehsdJsonProduct = JSON.parse(formData.data.quotationProductList[i].ehsdJson);
            if (ehsdJsonProduct.packMethod) {
              formData.data.quotationProductList[i].packMethod = ehsdJsonProduct.packMethod;
            }
            if (ehsdJsonProduct.tradeMethods) {
              formData.data.quotationProductList[i].tradeMethods = ehsdJsonProduct.tradeMethods;
            }
          }
        }
        let fileIds = formData.data.quotationProductList.map((item) => item.productId);
        proxy.post("/fileInfo/getList", { businessIdList: fileIds }).then((resFile) => {
          for (let i = 0; i < formData.data.quotationProductList.length; i++) {
            if (resFile[formData.data.quotationProductList[i].productId] && resFile[formData.data.quotationProductList[i].productId].length > 0) {
              formData.data.quotationProductList[i].fileUrl = resFile[formData.data.quotationProductList[i].productId][0].fileUrl;
            }
          }
        });
      }
      delete formData.data.id;
      delete formData.data.code;
      getCityData(formData.data.customerCountryId, "20");
      getCityData(formData.data.customerState, "30");
      if (formData.data.quotationProductList && formData.data.quotationProductList.length > 0) {
        formData.data.quotationProductList = formData.data.quotationProductList.map((item) => {
          delete item.id;
          return {
            ...item,
          };
        });
      }
      if (formData.data.quotationPayList && formData.data.quotationPayList.length > 0) {
        formData.data.quotationPayList = formData.data.quotationPayList.map((item) => {
          delete item.id;
          return {
            ...item,
          };
        });
      }
    });
  }
});
const clickCustomerProduct = () => {
  if (!formData.data.buyCorporationId) {
    return ElMessage("请先选择客户");
  }
  openProductCustomer.value = true;
};
// 向父组件暴露
defineExpose({
  submitData: formData.data,
  handleSubmit,
});
</script>

<style lang="scss" scoped>
::v-deep(.el-input-number .el-input__inner) {
  text-align: left;
}
.pic {
  object-fit: contain;
  width: 50px;
  height: 50px;
  cursor: pointer;
  vertical-align: middle;
}
.shrinkPadding {
  padding-right: 0 !important;
}
</style>
